<?php
namespace App\Controller;

use App\Controller\AppController;
use Cake\Filesystem\File;
use Cake\Utility\Inflector;

class LayoutsController extends AppController
{


  	public function initialize() {
  		parent::initialize();
  		$this->loadComponent('Configuration');
  		$this->loadComponent('Csrf');
  		$this->loadComponent('Cakeless');
  	}

    public function index() {
      $layout_name = $this->request->query('layout');
      if ($layout_name === null) {
        $layout_name="oh14";
      }


      $this->set('layout',$layout_name);

    }

    public function layout() {
      $layout_name = $this->request->query('name');
      if ($layout_name === null) {
        $layout_name="oh14";
      }


      $layout = $this->Configuration->getConfiguration('layout',$layout_name,'layouts'); // in future load name from session?
      $this->set('json',$layout);
      $this->render('/json');
    }

    public function template() {
      $name = $this->request->query('name');
      $file_template = new File(ROOT."/src/Template/" . Inflector::camelize($name) . "/template.html");
      $file_css = new File(ROOT."/src/Template/" . Inflector::camelize($name) . "/style.css");
      $file_js = new File(ROOT."/src/Template/" . Inflector::camelize($name) . "/script.js");
      $template=null;
      $css=null;
      $js=null;

			if ($file_template->exists() && $file_template->readable())
      {
        $template = $file_template->read();
        if ($file_css->exists() && $file_css->readable() ) {
          $css = $file_css->read();
          if ($css != "") {
            $css =
              $this->Cakeless->compile(
                "[data-template=".$name."]{\n" .
                  $css .
                "\n}"
              );
          } else {
            $css = null;
          }
        }
        if ($file_js->exists() && $file_js->readable() )
          $js = $file_js->read();
      }
      $out = array(
        "template" => $template,
        "css" => $css,
        "js" => $js
      );

      $this->set('json',$out);
      $this->render('/json');
    }
}
?>
