binder.loaded = function(panel, config) {
  console.log("departures: register with config [" + config + "]");
  $(panel).append('<div data-departure-view></div>');
  var innerContainer = $(panel).find('[data-departure-view]');

  var u = function() {
    update(panel,config,innerContainer);
  };
  setInterval(u, 60000);

  var r = function() {
    console.log(panel);
    resize(panel, innerContainer);
  };
  $(window).resize(r);

  u();
  r();
}

var update = function(panel,config,innerContainer) {
	console.log("departures: get data [" + config + "]");
	$.get("departures/?config=oh14", function(data) {
		var
			decodedData = JSON && JSON.parse(data) || $.parseJSON(data),
			tplDeparture = $(panel).find('template[data-departure]').html(),
			tplStop = $(panel).find('template[data-stop]').html(),
			tplInfo = $(panel).find('template[data-info]').html(),
			tplError = $(panel).find('template[data-error]').html(),
			tplVRRFError = $(panel).find('template[data-vrrf-error]').html(),
			elementArray = [];

		console.log("departures: check vrrf errors [" + config + "]");
		for (var i in decodedData.errors) {
			if (decodedData.errors[i]) {
				var
					buffer = $(tplVRRFError).clone();
				$(buffer).find('[data-stop]').html(i);
				$(buffer).find('[data-message]').html(decodedData.errors[i]);
				elementArray.push(buffer);
			}
		}
		console.log("departures: check error [" + config + "]");
		if (decodedData.error) {
			var
				buffer = $(tplError).clone();
			$(buffer).find('[data-message]').html(decodedData.error);
			elementArray.push(buffer);
		}
		console.log("departures: check information [" + config + "]");
		if (decodedData.info) {
			var
				buffer = $(tplInfo).clone();
			$(buffer).find('[data-message]').html(decodedData.info);
			elementArray.push(buffer);
		}
		console.log("departures: generate departure elements [" + config + "]");
		for (var i in decodedData.lines) {
			if (decodedData.lines[i]) {
				var
					store = decodedData.lines[i],
					lineBuffer = $(tplDeparture).clone(),
					stopsArray = [],
					stopsBuffer = $(lineBuffer).find('[data-stops]');
				$(lineBuffer).find('[data-transport] [data-number]').html(store.line.toUpperCase());
				$(lineBuffer).find('[data-transport] [data-name]').html(store.destination);
				for (var i in store.stops) {
					var
						subStore = store.stops[i],
						stopBuffer = $(tplStop).clone(),
						infoText = '';
					if (subStore.cancel == 1) {
						infoText = '+++&emsp;Fällt aus&emsp;+++';
					} else if (subStore.delay > 0) {
						infoText = '+++&emsp;Verspätung ca. ' + subStore.delay + ' Min.&emsp;+++';
					}
					if (subStore.info != "") {
						if (infoText != "") {
							infoText += '&emsp;&emsp;&emsp;&emsp;+++&emsp;' + subStore.info + '&emsp;+++';
						} else {
							infoText = '+++&emsp;' + subStore.info + '&emsp;+++';
						}
					}
					$(stopBuffer).find('[data-time]').html(subStore.time);
					$(stopBuffer).find('[data-name]').html(subStore.name);
					$(stopBuffer).find('[data-info] marquee').html(infoText);
					stopsArray.push(stopBuffer);
				}
				$(stopsBuffer).append(stopsArray);
				elementArray.push(lineBuffer);
			}
		}
		console.log("departures: insert new HTML [" + config + "]");
		$(innerContainer).empty().append(elementArray);
		resize(panel, innerContainer);
	});
}
var resize = function(panel, innerContainer) {
  //console.log(panel);
	var
		scale = $(panel).innerHeight() / 100,
		heads = $(innerContainer).find('[data-transport]'),
		datas = $(innerContainer).find('[data-stop]'),
		headsH = scale * 4,
		datasH = scale * 3;
	$(heads).css('height', headsH + 'px');
	$(heads).css('fontSize', (headsH-2) + 'px');
	$(heads).css('lineHeight', headsH + 'px');
	$(heads).find('[data-number]').css('width', headsH * 2);
	$(datas).css('height', datasH + 'px');
	$(datas).css('fontSize', (datasH-2) + 'px');
	$(datas).css('lineHeight', datasH + 'px');
}
