layout = {

  binder: null,

  processLayout: function(json, container) {
    switch(json.type) {
      case "ysplit":
        var cont = $("<div>").attr("data-container","split");
        $(container).append(cont);
        layout.processLayout(json.up, cont).css("height",json.cut+"%");
        layout.processLayout(json.down, cont).css("height",(100.0-json.cut)+"%");
        return cont;
      case "xsplit":
        var cont = $("<div>").attr("data-container","split");
        $(container).append(cont);
        layout.processLayout(json.left, cont).css("width",json.cut+"%");
        layout.processLayout(json.right, cont).css("width",(100.0-json.cut)+"%");
        return cont;
      case "panel":
        var p = $("<div>")
          .attr("data-container","panel")
          .attr("data-template",json.name)
          .attr("data-config",json.config);
        var cont = $("<div>").attr("data-container","panelContainer").append(p);
        $(container).append(cont);

        layout.insertTemplate(json.name,p);

        return cont;
      default:
        layout.error(json);
        break;
    }
  },

  insertTemplate: function(name, panel) {
    var tmp = null;
    for (ti in layout.templates) {
      if (layout.templates[ti].name == name)
      {
        layout.templates[ti].panels.push(panel);
        return;
      }

    }

    this.templates.push(
      {
        "name": name,
        "template": null,
        "panels": [panel],
        "script": function() {},
        "css": null,
        "loadTemplate": function() {
          var t = this;
          $.get("http://ib.2deep4real.de/layouts/template?name=" + this.name, function(e) {

            binder={loaded: layout.panelLoaded};
            if (e.js != null) {

            //  try {
                eval("function doStuff() {\n" + e.js + "\n}");
                doStuff();
                doStuff = null;
            /*  } catch (ex) {
                console.log("exception when running init for " + t.name + "\n" + ex);
              }*/
              if (typeof binder.loaded=='function') {
                t.script.prototype.loaded = binder.loaded;
              }
            }



            if (e.css!=null) {
              t.css = $("<style>").attr("type","text/css").attr("data-template",t.name).text(e.css);
              $("body").append(t.css);
            }
            t.template = $.parseHTML(e.template);

            for (p in t.panels) {
              t.panels[p].append(
                $(t.template).clone()
              ).ready(function() {
                if (t.script == null) {

                } else {
                  t.panels[p].js=new t.script();
                  try {
                    if (typeof t.panels[p].js.loaded == 'function')
                      t.panels[p].js.loaded(t.panels[p], t.panels[p].attr("data-config"));
                  } catch (ex) {
                    console.log("Layout: exception when running loading for " + t.name + "\n" + ex);
                  }
                }
              });
            }

          }).fail(function() {
            layout.error("get fail");
          });

        }
      }
    )
  },

  panelLoaded: function(panel) {
      console.log(panel);
  },

  loadLayout: function(layoutname) {
    var w = "http://ib.2deep4real.de/layouts/layout?name="+layoutname;
    console.log(w);
    $.get(w, function(e) {
        layout.processLayout(e, $("[data-container=main]"));
        for (var tmp in layout.templates) {
            layout.templates[tmp].loadTemplate();
        }
    }).fail(function() {
      layout.error("get fail");
    });
  },


  error: function(e) {
    console.log("Layout: Error " + e);
  },

  templates: [],

}
